package pvj8_dema;
// divny priklad

public class DemoVlakno4_priorita {

    public static void main(String[] args) {
        Thread.currentThread().setPriority(10);
        MojeVlakno4a lowPriority = new MojeVlakno4a(9, "Vlakno s nízkou prioritou");
        MojeVlakno4a highPriority = new MojeVlakno4a(3, "Vlakno s vysokou prioritou");
        lowPriority.start();
        highPriority.start();

        try {
            Thread.sleep(1000);
        } catch (InterruptedException e) {
            System.out.println("Hlavní vlákno přerušeno");
        }

        try {
            lowPriority.v.join();        lowPriority.stop();
            highPriority.v.join();        highPriority.stop();
        } catch (InterruptedException v) {
            System.out.println("Výjimka (InterruptedException v)");
        }


        System.out.println("Hlavni");
    }
}

class MojeVlakno4a implements Runnable {

    Thread v;
    private boolean spusteno = true;

    public MojeVlakno4a(int p, String tName) {
        v = new Thread(this, tName);
        v.setPriority(p);
    }

    public void run() {
        //  while (spusteno) 
        {
            System.out.println(v.getName() + " běží");
        }
        try {
            Thread.sleep(1000);
        } catch (InterruptedException e) {
            System.out.println("Hlavní vlákno přerušeno");
        }
    }

    public void stop() {
        spusteno = false;
        System.out.println(v.getName() + " zastaveno");
    }

    public void start() {
        System.out.println(v.getName() + " spuštěno");
        v.start();
    }
}
