package pvj8_dema;

class Zavorky {
    // synchronized
    //void zobrazit(String s) {

    synchronized void zobrazit(String s) { // kdyz pryc, tak neni synchronizace
        System.out.print("(");
        try {
            Thread.sleep(1000);
        } catch (InterruptedException e) {
            System.out.println(" Preruseno");
        }
        System.out.print(s);
        try {
            Thread.sleep(1000);
        } catch (InterruptedException e) {
            System.out.println(" Preruseno");
        }
        System.out.println(")");
    }
}

class MyThread implements Runnable {

    String s1;
    Zavorky z1;
    Thread v;

    public MyThread(Zavorky z2, String s2) {
        z1 = z2;
        s1 = s2;
        v = new Thread(this);
        v.start();
    }

    public void run() {
        z1.zobrazit(s1);
    }
}

/*
 * public void run() { synchronized (z1) { z1.zobrazit(s1); }
 *
 */
public class DemoVlakno5_zavorky {

    public static void main(String[] args) {
        Zavorky z1 = new Zavorky();
      //  Zavorky z2 = new Zavorky();
      //  Zavorky z3 = new Zavorky();
        MyThread name1 = new MyThread(z1, "Honza");
        MyThread name2 = new MyThread(z1, "Jana");
        MyThread name3 = new MyThread(z1, "Xaver");
        /*
         * try { name1.v.join(); name2.v.join(); name3.v.join();
         *
         * } catch (InterruptedException v) { System.out.println("Preruseno"); }
         *
         *
         */
    }
}
