package pvj8_dema;


class Fronta {

    int vyjmenovanaHodnota;
    boolean obsazeno = false;

    synchronized int vyjmout() {
        if (!obsazeno) {
            try {
                wait(); // zastavi  toto vlakno az do jeho probuzeni metodou notify() jinym vlaknem
            } catch (InterruptedException v) {
                System.out.println("Vyjmout: (InterruptedException ");
            }
        }
        obsazeno = false;
        System.out.println("Vyjmout:" + vyjmenovanaHodnota);
        notify();  // spust vlakno, ktere pozastavilo toto vlakno
        return vyjmenovanaHodnota;
    }

    synchronized void vlozit(int vyjmenovanaHodnota) {
        if (obsazeno) {
            try {
                wait(); // zastavi  toto vlakno az do jeho probuzeni metodou notify() jinym vlaknem
            } catch (InterruptedException v) {
                System.out.println("Vlozit: (InterruptedException ");
            }
        }
        this.vyjmenovanaHodnota = vyjmenovanaHodnota;
        obsazeno = true;
        System.out.println("Vlozit:" + vyjmenovanaHodnota);
        notify(); // spust vlakno, ktere pozastavilo toto vlakno
        //     return vyjmenovanaHodnota;
    }
}

class Vydavatel implements Runnable {

    Fronta f;
    Thread t;

    Vydavatel(Fronta f) {
        this.f = f;
        t = new Thread(this, "Vydavatel");
        t.start();
    }

    public void run() {
        for (int i = 0; i < 5; i++) {
            f.vlozit(i);
        }
    }
}

class Zakaznik implements Runnable {

    Fronta f;
    Thread t;

    Zakaznik(Fronta f) {
        this.f = f;
        t = new Thread(this, "Zakaznik");
        t.start();
    }

    public void run() {
        for (int i = 0; i < 5; i++) {
            /*
            try {
            Thread.sleep(1000);
            } catch (InterruptedException e) {
            System.out.println("Jsem");
            }
             */
            f.vyjmout();
        }

    }
}

public class DemoVlakno7 {

    public static void main(String[] args) {
        Fronta f = new Fronta();
        Vydavatel t1 = new Vydavatel(f);
        Zakaznik t2 = new Zakaznik(f);
        // if(t1.t.isAlive()) t1.notifyAll();
    }
}
