/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pvj8_new;

/**
 *
 * @author jelinek
 */

class Box {

    int cislo;
    boolean obsazeno = false;

    synchronized int vyjmout() {
        if (!obsazeno) {
            try {
                wait(); // zastavi  toto vlakno az do jeho probuzeni metodou notify() jinym vlaknem
            } catch (InterruptedException v) {
                System.out.println("Vyjmout: (InterruptedException ");
            }
        }
        obsazeno = !obsazeno;
        System.out.println( Thread.currentThread().getName() + " vyjme: " + cislo );
        notify();  // spust vlakno, ktere pozastavilo toto vlakno
        return cislo;
    }

    synchronized void vlozit(int cislo) {
        if (obsazeno) {
            try {
                wait(); // zastavi  toto vlakno az do jeho probuzeni metodou notify() jinym vlaknem
            } catch (InterruptedException v) {
                System.out.println("Vlozit: (InterruptedException ");
            }
        }
        this.cislo = cislo;
        obsazeno = !obsazeno;
        System.out.println( Thread.currentThread().getName() + " vlozi " + cislo );
        notify(); // spust vlakno, ktere pozastavilo toto vlakno

    }
}

class Vydavatel implements Runnable {

    Box f;
    Thread t;

    Vydavatel(Box f) {
        this.f = f;
        t = new Thread(this, "Vydavatel");
        t.start();
    }

    public void run() {
        for (int i = 0; i < 5; i++) {
            f.vlozit(i);
        }
    }
}

class Zakaznik implements Runnable {

    Box f;
    Thread t;

    Zakaznik(Box f) {
        this.f = f;
        t = new Thread(this, "Zakaznik");
        t.start();
    }

    public void run() {
        for (int i = 0; i < 5; i++) {
            f.vyjmout();
        }

    }
}

public class Synchro_Zak_Prodavac {

    public static void main(String[] args) {
        Box f = new Box();
        Vydavatel t1 = new Vydavatel(f);
        Zakaznik  t2 = new Zakaznik(f);
    }
}
