package pvj8_dema;


class MojeVlakno implements Runnable {
    String JmenoVlakna;
    Thread vlakno;
    MojeVlakno(String vlaknoName) {
        JmenoVlakna = vlaknoName;
        vlakno = new Thread(this, JmenoVlakna);
        vlakno.start();
    }
    public void run() {
        try {
            System.out.println("Vlákno.." + JmenoVlakna + " start");
            Thread.sleep(4000);
        } catch (InterruptedException e) {
            System.out.println("Výjimka: vlákno" + JmenoVlakna + "přerušeno");
        }
        System.out.println("Vlákno.." + JmenoVlakna + " konec");
    }
}

public class DemoVlakno3_join_isAlive {

    public static void main(String[] args) {
        MojeVlakno vlakno1 = new MojeVlakno("1");
        MojeVlakno vlakno2 = new MojeVlakno("2");
        MojeVlakno vlakno3 = new MojeVlakno("3");
        MojeVlakno vlakno4 = new MojeVlakno("4");
        System.out.println("Stav vlákna isAlive A --------------");
        System.out.println("Vlakno1 zije: " + vlakno1.vlakno.isAlive());
        System.out.println("Vlakno2 zije: " + vlakno2.vlakno.isAlive());
        System.out.println("Vlakno3 zije: " + vlakno3.vlakno.isAlive());
        System.out.println("Vlakno4 zije: " + vlakno4.vlakno.isAlive());
        // toto zkuste - try - vypustit, pak jeste po ukonceni hlavniho vlakna bezi dcerine

        try {
            System.out.println("Vlakno: join -------------------");
            vlakno1.vlakno.join();
           vlakno2.vlakno.join();  // zkuste toto zakomntovat
            vlakno3.vlakno.join();  // zkuste toto zakomntovat
            vlakno4.vlakno.join();  // zkuste toto zakomntovat

        } catch (InterruptedException e) {
            System.out.println("Výjimka: Hlavní vlákno přerušeno");
        }
        

        // toto zkuste vypustit
        System.out.println("Stav vlákna isAlive C ----------------------");
        System.out.println("Vlakno1: " + vlakno1.vlakno.isAlive());
        System.out.println("Vlakno2: " + vlakno2.vlakno.isAlive());
        System.out.println("Vlakno3: " + vlakno3.vlakno.isAlive());
        System.out.println("Vlakno4: " + vlakno4.vlakno.isAlive());
        System.out.println("Ukončení vlákna: Hlavní vlákno ukončeno");
    }
}


