package pvj8_dema;


class Fronta6 {

    int vyjmenovanaHodnota;
    boolean obsazeno = false;

    synchronized int vyjmout() {
        if (!obsazeno) {
            try {
                wait(); // zastavi  toto vlakno az do jeho probuzeni metodou notify() jinym vlaknem
            } catch (InterruptedException v) {
                System.out.println("Vyjmout: (InterruptedException ");
            }
        }
        obsazeno = false;
        System.out.println("Vyjmout:" + vyjmenovanaHodnota);
        notify();  // spust vlakno, ktere pozastavilo toto vlakno
        return vyjmenovanaHodnota;
    }

    synchronized void vlozit(int vyjmenovanaHodnota) {
        if (obsazeno) {
            try {
                wait(); // zastavi  toto vlakno az do jeho probuzeni metodou notify() jinym vlaknem
            } catch (InterruptedException v) {
                System.out.println("Vlozit: (InterruptedException ");
            }
        }
        this.vyjmenovanaHodnota = vyjmenovanaHodnota;
        obsazeno = true;
        System.out.println("Vlozit:" + vyjmenovanaHodnota);
        notify(); // spust vlakno, ktere pozastavilo toto vlakno
    }
}

class Vydavatel6 implements Runnable {

    Fronta6 f;
    Thread t;

    Vydavatel6(Fronta6 f) {
        this.f = f;
        t = new Thread(this, "Vydavatel6");
        t.start();
    }

    public void run() {
        for (int i = 0; i < 5; i++) {
            f.vlozit(i);
        }
    }
}

class Zakaznk6 implements Runnable {

    Fronta6 f;
    Thread t;

    Zakaznk6(Fronta6 f) {
        this.f = f;
        t = new Thread(this, "Zakaznk6");
        t.start();
    }

    public void run() {
        for (int i = 0; i < 5; i++) {
            /*
            try {
            Thread.sleep(1000);
            } catch (InterruptedException e) {
            System.out.println("Jsem");
            }
             */
            f.vyjmout();
        }

    }
}

public class DemoVlakno6_komunikace {

    public static void main(String[] args) {
        Fronta6 f = new Fronta6();
        Vydavatel6 t1 = new Vydavatel6(f);
        Zakaznk6 t2 = new Zakaznk6(f);
        // if(t1.t.isAlive()) t1.notifyAll();
    }
}
