
package pvj8_dema;


public class DemoVlakno8 {

    public static void main(String[] args) {
        MojeVlakno8 v1 = new MojeVlakno8();
        try {
            Thread.sleep(1000);
            v1.zastavitChod();
            System.out.println("Vlakno, chod zastaven");
            Thread.sleep(1000);
            v1.obnovitChod();
            System.out.println("Vlakno, chod obnoven");

            Thread.sleep(1000);
            v1.zastavitChod();
            System.out.println("Vlakno, chod zastaven");
            Thread.sleep(1000);
            v1.obnovitChod();
            System.out.println("Vlakno, chod obnoven");
        } catch (InterruptedException v) {
        }
        try {
            v1.v.join();
        } catch (InterruptedException v) {
            System.out.println("Hlavni vlankno preruseno");
        }
    }
}
class MojeVlakno8 implements Runnable {

    Thread v;
    boolean zastaven;

    MojeVlakno8() {
        v = new Thread(this, "Vlaakno");
        zastaven = false;
        v.start();
    }

    public void run() {
        try {
            for (int i = 0; i < 10; i++) {
                System.out.println("Vlakno běží" + i);
                Thread.sleep(500);
                synchronized (this) {
                    while (zastaven) {
                   System.out.println("Vlakno spí" + i);
                        wait();
                    }
                }
            }
        } catch (InterruptedException e) {
            System.out.println("Vlakno preruseno");
        }
        System.out.println("Vlakno ukonceno");
    }

    void zastavitChod() {
        System.out.println("Chod zastaven");
        zastaven = true;
    }

    synchronized void obnovitChod() {
        zastaven = false;
        System.out.println("Chod obnoven");
        notify();
    }
}

