/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pvj8_new;

/**
 *
 * @author jelinek
 */
// Use synchronize to control access.

class SumArray {
  private int sum;

  //int sumArray(int nums[]) {
  synchronized int sumArray(int nums[]) {
    sum = 0; // reset sum

    for(int i=0; i<nums.length; i++) {
      sum += nums[i];
      System.out.println("Running total for " +
             Thread.currentThread().getName() +
             " is " + sum);
      try {
        Thread.sleep(10); // allow task-switch
      }
      catch(InterruptedException exc) {
        System.out.println("Main thread interrupted.");
      }
    }
    return sum;
  }
}

class MyThreadSy implements Runnable {
  Thread thrd;
  static SumArray sa = new SumArray();
  int a[];
  int answer;

  // Construct a new thread.
  MyThreadSy(String name, int nums[]) {
    thrd = new Thread(this, name);
    thrd.start(); // start the thread
    a = nums;
  }

  // Begin execution of new thread.
  public void run() {
    int sum;

    System.out.println(thrd.getName() + " starting.");

    answer = sa.sumArray(a);
    System.out.println("Sum for " + thrd.getName() +
                       " is " + answer);

    System.out.println(thrd.getName() + " terminating.");
  }
}

class Sync {
  public static void main(String args[]) {
    int a[] = {1, 2, 3, 4, 5};

    MyThreadSy mt1 = new MyThreadSy("Child #1", a);
    MyThreadSy mt2 = new MyThreadSy("Child #2", a);
  }
}
