/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pvj8_new;

/**
 *
 * @author jelinek
 */
// Use a synchronized block to control access to SumArray.
class SumArrayP {
  private int sum;

  int sumArrayP(int nums[]) {
    sum = 0; // reset sum

    for(int i=0; i<nums.length; i++) {
      sum += nums[i];
      System.out.println("Running total for " +
             Thread.currentThread().getName() +
             " is " + sum);
      try {
        Thread.sleep(10); // allow task-switch
      }
      catch(InterruptedException exc) {
        System.out.println("Main thread interrupted.");
      }
    }
    return sum;
  }
}

class MyThreadP implements Runnable {
  Thread thrd;
  final static SumArrayP sa = new SumArrayP();
  int a[];
  int answer;

  // Construct a new thread.
  MyThreadP(String name, int nums[]) {
    thrd = new Thread(this, name);
    thrd.start(); // start the thread
    a = nums;
  }

  // Begin execution of new thread.
  public void run() {
    int sum;

    System.out.println(thrd.getName() + " starting.");

    // synchronize calls to sumArrayP()
    synchronized(sa) {
      answer = sa.sumArrayP(a);
    }
    System.out.println("Sum for " + thrd.getName() +
                       " is " + answer);

    System.out.println(thrd.getName() + " terminating.");
  }
}

class SyncPrikaz {
  public static void main(String args[]) {
    int a[] = {1, 2, 3, 4, 5};

    MyThreadP mt1 = new MyThreadP("Child #1", a);
    MyThreadP mt2 = new MyThreadP("Child #2", a);
/*
    try {
      mt1.thrd.join();
      mt2.thrd.join();
    } catch(InterruptedException exc) {
      System.out.println("Main thread interrupted.");
    }
 */
  }
}

