/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pvj8_new;

/**
 *
 * @author jelinek
 */
// No calls to wait() or notify().
class TickTockB {

  synchronized void tick(boolean running) {
    if(!running) { // stop the clock 
      return;
    }

    System.out.print("Tick ");
  }

  synchronized void tock(boolean running) {
    if(!running) { // stop the clock
      return;
    }

    System.out.println("Tock");
  }
}

class MyThreadB implements Runnable {
  Thread thrd;
  TickTockB ttOb;

  // Construct a new thread.
  MyThreadB(String name, TickTockB tt) {
    thrd = new Thread(this, name);
    ttOb = tt;
    thrd.start(); // start the thread
  }

  // Begin execution of new thread.
  public void run() {

    if(thrd.getName().compareTo("Tick") == 0) {
      for(int i=0; i<5; i++) ttOb.tick(true);
      ttOb.tick(false);
    }
    else {
      for(int i=0; i<5; i++) ttOb.tock(true);
      ttOb.tock(false);
    }
  }
}

class ThreadCom_bez {
  public static void main(String args[]) {
    TickTockB tt = new TickTockB();
    MyThreadB mt1 = new MyThreadB("Tick", tt);
    MyThreadB mt2 = new MyThreadB("Tock", tt);
/*
    try {
      mt1.thrd.join();
      mt2.thrd.join();
    } catch(InterruptedException exc) {
      System.out.println("Main thread interrupted.");
    }
    */
  }
}
